% Recursive Filtering and Estimation, Spring 2010
% Exercise class, 17.03.10
%
% Example "sampling of a joint PDF"
% Random number generator, implementation 1
%
% Sebastian Trimpe, strimpe(at)ethz.ch

function sample = jointPDF1()

% random number generator (uniform distribution)
u1 = rand;
u2 = rand;

% continuous R.V. y (uniform)
ys = u1;

% discrete R.V. x (from cdf given ys)
% Construct CDF for x, use ys as fixed parameter
cdf_x = [1-ys, 1];
xs = find(u2<=cdf_x,1,'first') - 1;

% Alternative:
% if u2<1-ys
%     xs = 0;
% else
%     xs = 1;
% end;

% return:
sample = [xs,ys];