% Recursive Filtering and Estimation, Spring 2010
% Exercise class, 17.03.10
%
% Script to run example "sampling of a joint PDF".
%
% Sebastian Trimpe, strimpe(at)ethz.ch


%% Generate samples
N = 1e5;        % number of samples (1e4, 1e5)
M = 100;        % number of bins for histogram = number of intervals  
                % that [0,1] is divided into (used for plotting)
bins = linspace(0,1,M);
                
samples1 = zeros(N,2);
samples2 = zeros(N,2);

for i=1:N
    samples1(i,:) = jointPDF1();    % generator 1
    samples2(i,:) = jointPDF2();    % generator 2
end;
       

%% Plot samples and desired pdf
y = linspace(0,1);

% histogram count:
% Count how many samples per interval defined by BINS.
counts1_x0 = histc(samples1(samples1(:,1)==0,2),bins);
counts2_x0 = histc(samples2(samples2(:,1)==0,2),bins);
counts1_x1 = histc(samples1(samples1(:,1)==1,2),bins);
counts2_x1 = histc(samples2(samples2(:,1)==1,2),bins);
% Note that (see help of histc) the element of counts* is the number of 
% samples that are equal to BINS(end),  Since this does not occur, we won't 
% plot the last element.

figure;
subplot(2,1,1);
plot(y,1-y,'r',bins(1:end-1),counts1_x0(1:end-1)/(N/M),'.',bins(1:end-1),counts2_x0(1:end-1)/(N/M),'.');
title('joint pdf for x=0');
xlabel('y');
ylabel('f(y,0)');
grid;
legend('desired','generator 1','generator 2');
%
subplot(2,1,2);
plot(y,y,'r',bins(1:end-1),counts1_x1(1:end-1)/(N/M),'.',bins(1:end-1),counts2_x1(1:end-1)/(N/M),'.');
title('joint pdf for x=1');
xlabel('y');
ylabel('f(y,1)');
grid;

